roboptim::Problem< F, CLIST > Class Template Reference
Optimization problems

`#include <roboptim/core/problem.hh>`

## Public Types

typedef CLIST | constraintsList_t
| Constraints types list. More...
typedef F | function_t
| Function type. More...
typedef boost::make_variant_over< typename detail::add_shared_ptr< CLIST >::type >::type | constraint_t
| Constraint's type. More...
typedef function_t::value_type | value_type
typedef std::vector< constraint_t > | constraints_t
| Constraints are represented as a vector of constraints. More...
typedef boost::optional< Function::vector_t > | startingPoint_t
| Optional vector defines a starting point. More...
typedef Function::interval_t | interval_t
typedef Function::intervals_t | intervals_t
typedef std::vector< value_type > | scales_t
| Scale vector. More...
typedef std::vector< intervals_t > | intervalsVect_t
| Vector of interval vectors. More...
typedef std::vector< scales_t > | scalesVect_t
| Vector of scale vectors. More...

## Public Member Functions

std::ostream & | print (std::ostream &o) const throw ()
| Display the problem on the specified output stream. More...
Constructors and destructors.
| Problem (const function_t &) throw ()
| Problem (const Problem< F, CLIST > &) throw ()
| Copy constructor. More...
template<typename F_ , typename CLIST_ >
| Problem (const Problem< F_, CLIST_ > &) throw ()
| Copy constructor (convert from another class of problem). More...
| ~Problem () throw ()
Cost function.
const function_t & | function () const throw ()
| Retrieve cost function. More...
intervals_t & | argumentBounds () throw ()
| Retrieve arguments bounds. More...
const intervals_t & | argumentBounds () const throw ()
| Retrieve arguments bounds. More...
scales_t & | argumentScales () throw ()
| Retrieve arguments scales. More...
const scales_t & | argumentScales () const throw ()
| Retrieve arguments scales. More...
Constraints.
const constraints_t & | constraints () const throw ()
| Retrieve constraints. More...
template<typename C >
void | addConstraint (boost::shared_ptr< C > constraint, interval_t interval, value_type scale=1.) throw (std::runtime_error)
| Add a constraint to the problem. More...
template<typename C >
void | addConstraint (boost::shared_ptr< C > constraint, intervals_t intervals, scales_t scales) throw (std::runtime_error)
| Add a constraint to the problem. More...
const intervalsVect_t & | boundsVector () const throw ()
| Retrieve constraints bounds vector. More...
const scalesVect_t & | scalesVector () const throw ()
| Retrieve constraints scales vector. More...
Starting point (initial guess).
startingPoint_t & | startingPoint () throw ()
| Set the initial guess. More...
const startingPoint_t & | startingPoint () const throw ()
| Get the initial guess. More...

## Friends

template<typename F_ , typename CLIST_ >
class | Problem

## Detailed Description

### template<typename F, typename CLIST>
class roboptim::Problem< F, CLIST >

Examples:
  problem-cc.cc.